> ## Documentation Index
> Fetch the complete documentation index at: https://kosli-reference-docs-v2-30-1.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# List versions of a control

> **Beta** — the Controls feature is in beta. Requests from organizations without it enabled receive `403 Forbidden`.



## OpenAPI

````yaml https://app.kosli.com/api/v2/openapi.json get /controls/{org}/{identifier}/versions
openapi: 3.1.0
info:
  title: Kosli API
  summary: The API for communicating with Kosli
  description: >

    # Authentication 


    When making requests against Kosli API, you can authenticate your requests
    using a bearer token. 

    Set the bearer token in the request Authorization header to a valid API
    key. 

    API Keys can be personal or for service accounts. Check the [service
    accounts
    documentation](https://docs.kosli.com/getting_started/service-accounts/) for
    details. 


    ## Curl example


    ```shell

    curl -H "Authorization: Bearer <<your-api-key>>"
    https://app.kosli.com/api/v2/environments/<<your-org-name>>

    ```
  version: '2.0'
servers:
  - url: https://app.kosli.com/api/v2
    description: EU
  - url: https://app.us.kosli.com/api/v2
    description: US
security:
  - HTTPBearer: []
paths:
  /controls/{org}/{identifier}/versions:
    get:
      tags:
        - Controls
      summary: List versions of a control
      description: >-
        **Beta** — the Controls feature is in beta. Requests from organizations
        without it enabled receive `403 Forbidden`.
      operationId: list_control_versions
      parameters:
        - name: identifier
          in: path
          required: true
          schema:
            type: string
            title: Identifier
        - name: org
          in: path
          required: true
          schema:
            type: string
            title: Org
        - name: page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            description: Page number
            default: 1
            title: Page
          description: Page number
        - name: per_page
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 1
            description: Number of versions per page
            default: 15
            title: Per Page
          description: Number of versions per page
        - name: sort_direction
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/SortDirection'
            description: Sort direction by version number
            default: desc
          description: Sort direction by version number
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ControlVersionListResponse'
        '403':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/fastapi_app__errors__ForbiddenResponse___locals___ForbiddenResponseModel__8
          description: Forbidden
        '404':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/fastapi_app__errors__NotFoundResponse___locals___NotFoundResponseModel__41
          description: Not Found
      security:
        - HTTPBearer: []
        - HTTPBasic: []
components:
  schemas:
    SortDirection:
      type: string
      enum:
        - asc
        - desc
      title: SortDirection
    ControlVersionListResponse:
      properties:
        _links:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Links
        page:
          type: integer
          title: Page
        per_page:
          type: integer
          title: Per Page
        total_pages:
          type: integer
          title: Total Pages
        total_count:
          type: integer
          title: Total Count
        versions:
          items:
            $ref: '#/components/schemas/ControlVersionResponse'
          type: array
          title: Versions
      additionalProperties: false
      type: object
      required:
        - page
        - per_page
        - total_pages
        - total_count
        - versions
      title: ControlVersionListResponse
    fastapi_app__errors__ForbiddenResponse___locals___ForbiddenResponseModel__8:
      properties:
        message:
          type: string
          title: Message
          description: Error message
        errors:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Errors
          description: Validation errors by field
      type: object
      required:
        - message
      title: ForbiddenResponseModel
      examples:
        - message: You don't have permission to access this resource
    fastapi_app__errors__NotFoundResponse___locals___NotFoundResponseModel__41:
      properties:
        message:
          type: string
          title: Message
          description: Error message
        errors:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Errors
          description: Validation errors by field
      type: object
      required:
        - message
      title: NotFoundResponseModel
      description: Control not found
      examples:
        - message: Control not found
    ControlVersionResponse:
      properties:
        identifier:
          type: string
          title: Identifier
        version:
          type: integer
          title: Version
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        links:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Links
        created_at:
          anyOf:
            - type: number
            - type: 'null'
          title: Created At
        created_by:
          type: string
          title: Created By
        archived:
          type: boolean
          title: Archived
          default: false
        status:
          anyOf:
            - type: string
              enum:
                - created
                - updated
                - archived
                - unarchived
            - type: 'null'
          title: Status
      type: object
      required:
        - identifier
        - version
        - name
        - created_by
      title: ControlVersionResponse
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````